<?php
namespace Teknisa\FIS\Modules\Acessorias\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DataSource\DataSet;

class Fis75002EfdReinfReportController extends \Zeedhi\Framework\Controller\Report{
       
        protected $fileServiceUrl;
        protected $reportMapping = array(
            'CONSULTAR2099' => array(
                'strategy' => "BIRT",
                'parameterMapping' => array(
                    'EMPRESA'=> "EMPRESA",
                    'PERIODO'=> "PERIODO",
                    'URL_XML'=> "URL_XML"
                )
            ),
            'PREVIEWREINF' => array(
                'strategy' => "BIRT",
                'parameterMapping' => array(
                    'EMPRESA'=> "EMPRESA",
                    'DTINI' => "DTINI",
                    'DTFIN' => "DTFIM",
                    '2010'  =>  "2010",
                    '2020'  =>  "2020",
                    'P_NRORG' => "P_NRORG"
                )
            ),
        );
       
        public function __construct($reportService, $fileServiceUrl, $environment) {
            parent::__construct($reportService);
            $this->fileServiceUrl   = $fileServiceUrl;
            $this->environment      = $environment;
            set_time_limit(0);
        }
       
       public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response) {
           $row = $request->getRow();
           
           if(isset($row['URL_XML'])) $row['URL_XML'] = $this->fileServiceUrl.'/'.$row['URL_XML'];
           else {
               if($row["IDEVENTO"] == "2010") $row["2010"] = "S";
               else if($row["IDEVENTO"] == "2020") $row["2020"] = "S";
               else {
                   $row["2010"] = "S";
                   $row["2020"] = "S";
               }
               
               $mes = substr($row["PERIODO"], 0, 2);      
               $ano = substr($row["PERIODO"], 3, 4);
               $ultimo_dia = date("t", mktime(0,0,0,$mes,'01',$ano)); 
               $row["DTINI"] = '01/'.$mes.'/'.$ano;
               $row["DTFIN"] = $ultimo_dia.'/'.$mes.'/'.$ano;
               $row["P_NRORG"] = $this->environment->getNrorgTrab();
           }
       }
};