<?php
namespace Teknisa\FIS\Services;

use Zeedhi\Framework\DataSource\FilterCriteria;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;
use Doctrine\ORM\EntityManager;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\DataSet;
use Teknisa\FIS\Factories\Ger01300PaisFactory;

class Ger01300PaisService{
    protected $dataSourceManager;
    protected $ger01300paisfactory;

    public function __construct($dataSourceManager, $ger01300paisfactory){
        $this->dataSourceManager = $dataSourceManager;
        $this->ger01300paisfactory = $ger01300paisfactory;
    }

    public function buscar($condicao){
        return $this->dataSourceManager->findBy($condicao);
    }


    public function savePais($row){
        $this->verficaNomePais($row);
        if($row['__is_new']){
            $this->verficaCodigoPais($row);
        }
        $array[] = $row;
        $dataSet = new DataSet('pais', $array);
        $this->dataSourceManager->persist($dataSet);
    }

    //não permite salvar paises com mesmo nome
    public function verficaNomePais($row){
        $resultadoBanco = $this->ger01300paisfactory->verficaNomePais($row);
        if(!empty($resultadoBanco )){
            // no caso de edição para verificar se o pais ja existe na base e está sendo editado
            if($resultadoBanco[0]['CDPAIS']  !== $row['CDPAIS']){
                throw new \Exception("Nome já cadastrado.", 1);

            }
        }
    }

    //não permite salvar paises com mesmo código
    public function verficaCodigoPais($row){
        $resultadoBanco = $this->ger01300paisfactory->verficaCodigoPais($row);
        if(!empty($resultadoBanco)){
            throw new \Exception("Código já cadastrado.", 1);
        }
    }

}